﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PowerMonitor
{
    public partial class MainForm : Form
    {
        private Timer MonitorTimer = new Timer();
        
        
        public MainForm() {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e) {
            base.OnLoad(e);

            this.MonitorTimer.Interval = 5000; // 5초에 한번씩 상태를 체크
            this.MonitorTimer.Tick += new EventHandler(MonitorTimer_Tick);
            this.MonitorTimer.Start();
            // 최초 호출
            this.UpdateText();
            this.UpdateIcon();
        }


        protected override void OnClosing(CancelEventArgs e) {
            base.OnClosing(e);
            this.MonitorTimer.Stop();
        }


        void MonitorTimer_Tick(object sender, EventArgs e) {
            this.UpdateText();
            this.UpdateIcon();
        }


        private void UpdateText() {
            PowerStatus status = SystemInformation.PowerStatus;

            this.lblChargeStatus.Text = status.BatteryChargeStatus.ToString();
            this.lblFullLifeTime.Text = (status.BatteryFullLifetime != -1 ? status.BatteryFullLifetime.ToString() : "-");
            this.lblPowerStatus.Text = status.PowerLineStatus.ToString();
            this.lblRemainLifeTime.Text = (status.BatteryLifeRemaining != -1 ? TimeSpan.FromSeconds(status.BatteryLifeRemaining).ToString() : "-");
            this.progBarPower.Value = (int)(status.BatteryLifePercent != 255 ? status.BatteryLifePercent * 100 : 0);
        }


        private void UpdateIcon() {
            PowerStatus status = SystemInformation.PowerStatus;
            if (status.PowerLineStatus == PowerLineStatus.Offline) {
                if (status.BatteryLifePercent > 0.5) {
                    this.picBoxPower.Image = PowerMonitor.Resource1.BatteryGreen;
                } else {
                    this.picBoxPower.Image = PowerMonitor.Resource1.BatteryRed;
                }
            } else if (status.PowerLineStatus == PowerLineStatus.Online) {
                this.picBoxPower.Image = PowerMonitor.Resource1.PowerGreen;
            } else if(status.PowerLineStatus == PowerLineStatus.Unknown) {
                this.picBoxPower.Image = PowerMonitor.Resource1.unkown;
            }
        }
    }
}
